From 7b4569214ed3c271c2876d2a955457d00d6d1381 Mon Sep 17 00:00:00 2001
From: Ludwig Krispenz <lkrispen@redhat.com>
Date: Mon, 8 Feb 2016 16:13:03 +0100
Subject: [PATCH] remove changelog4 and legacy consumer code

---
 Makefile.am                                        |  12 -
 Makefile.in                                        | 132 ----
 ldap/servers/plugins/replication/cl4.h             |  73 --
 ldap/servers/plugins/replication/cl4_api.c         | 804 ---------------------
 ldap/servers/plugins/replication/cl4_api.h         |  75 --
 ldap/servers/plugins/replication/cl4_init.c        | 357 ---------
 ldap/servers/plugins/replication/legacy_consumer.c | 701 ------------------
 ldap/servers/plugins/replication/repl.h            |  35 -
 ldap/servers/plugins/replication/repl5.h           |   1 -
 ldap/servers/plugins/replication/repl5_plugins.c   | 163 +----
 .../plugins/replication/repl5_protocol_util.c      |   9 -
 ldap/servers/plugins/replication/repl5_replica.c   | 168 +----
 .../plugins/replication/repl5_replica_config.c     |  29 +-
 ldap/servers/plugins/replication/repl_add.c        |  38 -
 ldap/servers/plugins/replication/repl_bind.c       |  58 --
 ldap/servers/plugins/replication/repl_compare.c    |  48 --
 ldap/servers/plugins/replication/repl_connext.c    |   1 -
 ldap/servers/plugins/replication/repl_delete.c     |  34 -
 ldap/servers/plugins/replication/repl_extop.c      |   7 -
 ldap/servers/plugins/replication/repl_init.c       | 302 --------
 ldap/servers/plugins/replication/repl_modify.c     |  37 -
 ldap/servers/plugins/replication/repl_modrdn.c     |  36 -
 ldap/servers/plugins/replication/repl_opext.c      |   5 -
 ldap/servers/plugins/replication/repl_ops.c        | 188 -----
 ldap/servers/plugins/replication/repl_rootdse.c    |   1 -
 ldap/servers/plugins/replication/repl_search.c     |  33 -
 26 files changed, 4 insertions(+), 3343 deletions(-)
 delete mode 100644 ldap/servers/plugins/replication/cl4.h
 delete mode 100644 ldap/servers/plugins/replication/cl4_api.c
 delete mode 100644 ldap/servers/plugins/replication/cl4_api.h
 delete mode 100644 ldap/servers/plugins/replication/cl4_init.c
 delete mode 100644 ldap/servers/plugins/replication/legacy_consumer.c
 delete mode 100644 ldap/servers/plugins/replication/repl_add.c
 delete mode 100644 ldap/servers/plugins/replication/repl_bind.c
 delete mode 100644 ldap/servers/plugins/replication/repl_compare.c
 delete mode 100644 ldap/servers/plugins/replication/repl_delete.c
 delete mode 100644 ldap/servers/plugins/replication/repl_init.c
 delete mode 100644 ldap/servers/plugins/replication/repl_modify.c
 delete mode 100644 ldap/servers/plugins/replication/repl_modrdn.c
 delete mode 100644 ldap/servers/plugins/replication/repl_ops.c
 delete mode 100644 ldap/servers/plugins/replication/repl_search.c

diff --git a/Makefile.am b/Makefile.am
index 9b19bd4..e5d0210 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -337,7 +337,6 @@ dist_noinst_HEADERS = \
 	ldap/servers/plugins/uiduniq/plugin-utils.h \
 	ldap/servers/plugins/memberof/memberof.h \
 	ldap/servers/plugins/replication/cl5_api.h \
-	ldap/servers/plugins/replication/cl4_api.h \
 	ldap/servers/plugins/replication/llist.h \
 	ldap/servers/plugins/replication/repl_shared.h \
 	ldap/servers/plugins/replication/csnpl.h \
@@ -351,7 +350,6 @@ dist_noinst_HEADERS = \
 	ldap/servers/plugins/replication/cl5_test.h \
 	ldap/servers/plugins/replication/repl5_ruv.h \
 	ldap/servers/plugins/replication/cl5_clcache.h \
-	ldap/servers/plugins/replication/cl4.h \
 	ldap/servers/plugins/replication/cl_crypt.h \
 	ldap/servers/plugins/replication/urp.h \
 	ldap/servers/plugins/replication/winsync-plugin.h \
@@ -1418,27 +1416,17 @@ libreplication_plugin_la_SOURCES = ldap/servers/plugins/replication/cl5_api.c \
 	ldap/servers/plugins/replication/cl5_init.c \
 	ldap/servers/plugins/replication/cl_crypt.c \
 	ldap/servers/plugins/replication/csnpl.c \
-	ldap/servers/plugins/replication/legacy_consumer.c \
 	ldap/servers/plugins/replication/llist.c \
-	ldap/servers/plugins/replication/repl_add.c \
-	ldap/servers/plugins/replication/repl_bind.c \
-	ldap/servers/plugins/replication/repl_compare.c \
 	ldap/servers/plugins/replication/repl_connext.c \
 	ldap/servers/plugins/replication/repl_controls.c \
-	ldap/servers/plugins/replication/repl_delete.c \
 	ldap/servers/plugins/replication/repl_entry.c \
 	ldap/servers/plugins/replication/repl_ext.c \
 	ldap/servers/plugins/replication/repl_extop.c \
 	ldap/servers/plugins/replication/repl_globals.c \
-	ldap/servers/plugins/replication/repl_init.c \
-	ldap/servers/plugins/replication/repl_modify.c \
-	ldap/servers/plugins/replication/repl_modrdn.c \
 	ldap/servers/plugins/replication/repl_monitor.c \
 	ldap/servers/plugins/replication/repl_objset.c \
 	ldap/servers/plugins/replication/repl_opext.c \
-	ldap/servers/plugins/replication/repl_ops.c \
 	ldap/servers/plugins/replication/repl_rootdse.c \
-	ldap/servers/plugins/replication/repl_search.c \
 	ldap/servers/plugins/replication/repl_session_plugin.c \
 	ldap/servers/plugins/replication/repl5_agmt.c \
 	ldap/servers/plugins/replication/repl5_agmtlist.c \
diff --git a/ldap/servers/plugins/replication/repl.h b/ldap/servers/plugins/replication/repl.h
index 69667c6..2ee45ed 100644
--- a/ldap/servers/plugins/replication/repl.h
+++ b/ldap/servers/plugins/replication/repl.h
@@ -40,7 +40,6 @@
 #include "portable.h" /* GGOODREPL - is this cheating? */
 #include "ldaplog.h"
 #include "repl_shared.h"
-#include "cl4.h"
 
 typedef struct schedule_item
 {
@@ -167,35 +166,11 @@ typedef struct repl {
 int repl_rootdse_init();
 
 /* In repl.c */
-Slapi_Entry *get_changerecord(const chglog4Info *cl4, changeNumber cnum, int *err);
-changeNumber replog_get_firstchangenum(const chglog4Info *cl4, int *err);
-changeNumber replog_get_lastchangenum(const chglog4Info *cl4, int *err);
 void changelog_housekeeping(time_t cur_time );
 
 /* In repl_config.c */
 int repl_config_init ();
 
-/* Legacy Plugin Functions */
-
-int legacy_preop_bind( Slapi_PBlock *pb );
-int legacy_bepreop_bind( Slapi_PBlock *pb );
-int legacy_postop_bind( Slapi_PBlock *pb );
-int legacy_preop_add( Slapi_PBlock *pb );
-int legacy_bepreop_add( Slapi_PBlock *pb );
-int legacy_postop_add( Slapi_PBlock *pb );
-int legacy_preop_modify( Slapi_PBlock *pb );
-int legacy_bepreop_modify( Slapi_PBlock *pb );
-int legacy_postop_modify( Slapi_PBlock *pb );
-int legacy_preop_modrdn( Slapi_PBlock *pb );
-int legacy_bepreop_modrdn( Slapi_PBlock *pb );
-int legacy_postop_modrdn( Slapi_PBlock *pb );
-int legacy_preop_delete( Slapi_PBlock *pb );
-int legacy_bepreop_delete( Slapi_PBlock *pb );
-int legacy_postop_delete( Slapi_PBlock *pb );
-int legacy_preop_search( Slapi_PBlock *pb );
-int legacy_preop_compare( Slapi_PBlock *pb );
-int legacy_pre_entry( Slapi_PBlock *pb );
-int legacy_bepostop_assignchangenum( Slapi_PBlock *pb );
 
 int replication_plugin_start( Slapi_PBlock *pb );
 int replication_plugin_poststart( Slapi_PBlock *pb );
@@ -240,16 +215,6 @@ extern char	*type_objectclass;
 typedef int	(*IFP)();
 #endif
 
-/* In cl4.c */
-
-changeNumber ldapi_assign_changenumber(chglog4Info *cl4);
-changeNumber ldapi_get_last_changenumber(chglog4Info *cl4);
-changeNumber ldapi_get_first_changenumber(chglog4Info *cl4);
-void ldapi_commit_changenumber(chglog4Info *cl4, changeNumber cnum);
-void ldapi_set_first_changenumber(chglog4Info *cl4, changeNumber cnum);
-void ldapi_set_last_changenumber(chglog4Info *cl4, changeNumber cnum);
-void ldapi_initialize_changenumbers(chglog4Info *cl4, changeNumber first, changeNumber last);
-
 #define	LDBM_TYPE				"ldbm"
 #define	CHANGELOG_LDBM_TYPE		"changelog-ldbm"
 
diff --git a/ldap/servers/plugins/replication/repl5.h b/ldap/servers/plugins/replication/repl5.h
index 307da82..c13dd0c 100644
--- a/ldap/servers/plugins/replication/repl5.h
+++ b/ldap/servers/plugins/replication/repl5.h
@@ -27,7 +27,6 @@
 #include "repl_shared.h"
 #include "llist.h"
 #include "repl5_ruv.h"
-#include "cl4.h"
 #include "plstr.h"
 
 #define START_UPDATE_DELAY 2 /* 2 second */
diff --git a/ldap/servers/plugins/replication/repl5_plugins.c b/ldap/servers/plugins/replication/repl5_plugins.c
index c2fa214..0f3b9c8 100644
--- a/ldap/servers/plugins/replication/repl5_plugins.c
+++ b/ldap/servers/plugins/replication/repl5_plugins.c
@@ -56,7 +56,6 @@ static int process_postop (Slapi_PBlock *pb);
 static int cancel_opcsn (Slapi_PBlock *pb); 
 static int ruv_tombstone_op (Slapi_PBlock *pb);
 static PRBool process_operation (Slapi_PBlock *pb, const CSN *csn);
-static PRBool is_mmr_replica (Slapi_PBlock *pb);
 static const char *replica_get_purl_for_op (const Replica *r, Slapi_PBlock *pb, const CSN *opcsn);
 
 /*
@@ -147,29 +146,9 @@ multimaster_preop_add (Slapi_PBlock *pb)
     Slapi_Operation *op;
     int is_replicated_operation;
     int is_fixup_operation;
-    int is_legacy_operation;
 
     slapi_pblock_get(pb, SLAPI_OPERATION, &op);
 
-    /* If there is no replica or it is a legacy consumer - we don't need to continue.
-       Legacy plugin is handling 4.0 consumer code */
-    /* but if it is legacy, csngen_handler needs to be assigned here */
-    is_legacy_operation =
-        operation_is_flag_set(op,OP_FLAG_LEGACY_REPLICATION_DN);
-    if (is_legacy_operation)
-    {
-        copy_operation_parameters(pb);
-        slapi_operation_set_csngen_handler(op,
-                                           (void*)replica_generate_next_csn);
-        return SLAPI_PLUGIN_SUCCESS;
-    }
-
-    if (!is_mmr_replica (pb))
-    {
-        copy_operation_parameters(pb);
-        return SLAPI_PLUGIN_SUCCESS;
-    }
-
     is_replicated_operation= operation_is_flag_set(op,OP_FLAG_REPLICATED);
     is_fixup_operation= operation_is_flag_set(op,OP_FLAG_REPL_FIXUP);
 
@@ -276,30 +255,9 @@ multimaster_preop_delete (Slapi_PBlock *pb)
     Slapi_Operation *op;
     int is_replicated_operation;
     int is_fixup_operation;
-    int is_legacy_operation;
 
     slapi_pblock_get(pb, SLAPI_OPERATION, &op);
 
-    /* If there is no replica or it is a legacy consumer - we don't need to continue.
-       Legacy plugin is handling 4.0 consumer code */
-    /* but if it is legacy, csngen_handler needs to be assigned here */
-    is_legacy_operation =
-        operation_is_flag_set(op,OP_FLAG_LEGACY_REPLICATION_DN);
-    if (is_legacy_operation)
-    {
-        copy_operation_parameters(pb);
-    	slapi_operation_set_replica_attr_handler ( op, (void*)replica_get_attr );
-        slapi_operation_set_csngen_handler(op,
-                                           (void*)replica_generate_next_csn);
-        return SLAPI_PLUGIN_SUCCESS;
-    }
-
-    if (!is_mmr_replica (pb))
-    {
-        copy_operation_parameters(pb);
-        return SLAPI_PLUGIN_SUCCESS;
-    }
-
     is_replicated_operation= operation_is_flag_set(op,OP_FLAG_REPLICATED);
     is_fixup_operation= operation_is_flag_set(op,OP_FLAG_REPL_FIXUP);
 
@@ -376,29 +334,9 @@ multimaster_preop_modify (Slapi_PBlock *pb)
     Slapi_Operation *op;
     int is_replicated_operation;
     int is_fixup_operation;
-    int is_legacy_operation;
 
     slapi_pblock_get(pb, SLAPI_OPERATION, &op);
 
-    /* If there is no replica or it is a legacy consumer - we don't need to continue.
-       Legacy plugin is handling 4.0 consumer code */
-    /* but if it is legacy, csngen_handler needs to be assigned here */
-    is_legacy_operation =
-        operation_is_flag_set(op,OP_FLAG_LEGACY_REPLICATION_DN);
-    if (is_legacy_operation)
-    {
-        copy_operation_parameters(pb);
-        slapi_operation_set_csngen_handler(op,
-                                           (void*)replica_generate_next_csn);
-        return SLAPI_PLUGIN_SUCCESS;
-    }
-
-    if (!is_mmr_replica (pb))
-    {
-        copy_operation_parameters(pb);
-        return SLAPI_PLUGIN_SUCCESS;
-    }
-
     is_replicated_operation= operation_is_flag_set(op,OP_FLAG_REPLICATED);
     is_fixup_operation= operation_is_flag_set(op,OP_FLAG_REPL_FIXUP);
 
@@ -478,29 +416,9 @@ multimaster_preop_modrdn (Slapi_PBlock *pb)
     Slapi_Operation *op;
     int is_replicated_operation;
     int is_fixup_operation;
-    int is_legacy_operation;
 
     slapi_pblock_get(pb, SLAPI_OPERATION, &op);
 
-    /* If there is no replica or it is a legacy consumer - we don't need to continue.
-       Legacy plugin is handling 4.0 consumer code */
-    /* but if it is legacy, csngen_handler needs to be assigned here */
-    is_legacy_operation =
-        operation_is_flag_set(op,OP_FLAG_LEGACY_REPLICATION_DN);
-    if (is_legacy_operation)
-    {
-        copy_operation_parameters(pb);
-        slapi_operation_set_csngen_handler(op,
-                                           (void*)replica_generate_next_csn);
-        return SLAPI_PLUGIN_SUCCESS;
-    }
-
-    if (!is_mmr_replica (pb))
-    {
-        copy_operation_parameters(pb);
-        return SLAPI_PLUGIN_SUCCESS;
-    }
-
     is_replicated_operation= operation_is_flag_set(op,OP_FLAG_REPLICATED);
     is_fixup_operation= operation_is_flag_set(op,OP_FLAG_REPL_FIXUP);
 
@@ -997,7 +915,6 @@ copy_operation_parameters(Slapi_PBlock *pb)
 static int
 update_ruv_component(Replica *replica, CSN *opcsn, Slapi_PBlock *pb)
 {
-    PRBool legacy;
     char *purl;
     int rc = RUV_NOTFOUND;
 
@@ -1005,18 +922,10 @@ update_ruv_component(Replica *replica, CSN *opcsn, Slapi_PBlock *pb)
 		return rc;
 
 	/* Replica configured, so update its ruv */
-	legacy = replica_is_legacy_consumer (replica);
-	if (legacy)
-		purl = replica_get_legacy_purl (replica);
-	else
-		purl = (char*)replica_get_purl_for_op (replica, pb, opcsn);
+	purl = (char*)replica_get_purl_for_op (replica, pb, opcsn);
 
 	rc = replica_update_ruv(replica, opcsn, purl);
 
-	if (legacy)
-	{
-		slapi_ch_free ((void**)&purl);
-	}
 	return rc;
 }
 
@@ -1484,29 +1393,6 @@ process_operation (Slapi_PBlock *pb, const CSN *csn)
     return (rc == RUV_SUCCESS);
 }
 
-static PRBool 
-is_mmr_replica (Slapi_PBlock *pb)
-{
-    Object *r_obj;
-    Replica *r;
-    PRBool mmr;
-
-    r_obj = replica_get_replica_for_op(pb);
-    if (r_obj == NULL)
-    {
-        return PR_FALSE;
-    }   
-
-    r = (Replica*)object_get_data (r_obj);
-    PR_ASSERT (r);
-
-    mmr = !replica_is_legacy_consumer (r);
-
-    object_release (r_obj);
-
-    return mmr;
-}
-
 static const char *replica_get_purl_for_op (const Replica *r, Slapi_PBlock *pb, const CSN *opcsn)
 {
     int is_replicated_op;
@@ -1547,53 +1433,6 @@ static const char *replica_get_purl_for_op (const Replica *r, Slapi_PBlock *pb,
     return purl;   
 }
 
-#ifdef NOTUSED
-/* ONREPL at the moment, I decided not to trim copiedFrom and copyingFrom
-   attributes when sending operation to replicas. This is because, each
-   operation results in a state information stored in the database and
-   if we don't replay all operations we will endup with state inconsistency.
-
-   Keeping the function just in case
- */
-static void strip_legacy_info (slapi_operation_parameters *op_params)
-{
-    switch (op_params->operation_type)
-    {
-        case SLAPI_OPERATION_ADD:       
-                slapi_entry_delete_values_sv(op_params->p.p_add.target_entry, 
-                                             type_copiedFrom, NULL);
-                slapi_entry_delete_values_sv(op_params->p.p_add.target_entry, 
-                                             type_copyingFrom, NULL);
-                break;
-        case SLAPI_OPERATION_MODIFY:
-        {        
-                Slapi_Mods smods;
-                LDAPMod *mod;
-
-                slapi_mods_init_byref(&smods, op_params->p.p_modify.modify_mods);
-                mod = slapi_mods_get_first_mod(&smods);
-                while (mod)
-                {
-                    /* modify just to update copiedFrom or copyingFrom attribute 
-                       does not contain modifiersname or modifytime - so we don't
-                       have to strip them */
-                    if (strcasecmp (mod->mod_type, type_copiedFrom) == 0 ||
-                        strcasecmp (mod->mod_type, type_copyingFrom) == 0)
-                        slapi_mods_remove(&smods);
-                    mod = slapi_mods_get_next_mod(&smods);
-                }
-
-                op_params->p.p_modify.modify_mods = slapi_mods_get_ldapmods_passout (&smods);
-                slapi_mods_done (&smods);
-
-                break;
-        }
-
-        default: break;
-    }
-}
-#endif
-
 /* this function is called when state of a backend changes */
 void 
 multimaster_be_state_change (void *handle, char *be_name, int old_be_state, int new_be_state)
diff --git a/ldap/servers/plugins/replication/repl5_protocol_util.c b/ldap/servers/plugins/replication/repl5_protocol_util.c
index ce27a8a..86c4a1a 100644
--- a/ldap/servers/plugins/replication/repl5_protocol_util.c
+++ b/ldap/servers/plugins/replication/repl5_protocol_util.c
@@ -367,14 +367,6 @@ acquire_replica(Private_Repl_Protocol *prp, char *prot_oid, RUV **ruv)
 						}
 						return_value = ACQUIRE_REPLICA_BUSY;
 						break;
-					case NSDS50_REPL_LEGACY_CONSUMER:
-						/* remote replica is a legacy consumer */
-						slapi_log_error(SLAPI_LOG_FATAL, repl_plugin_name,
-							"%s: Unable to acquire replica: the replica "
-							"is supplied by a legacy supplier. "
-							"Replication is aborting.\n", agmt_get_long_name(prp->agmt));
-						return_value = ACQUIRE_FATAL_ERROR;
-						break;
 					case NSDS50_REPL_REPLICAID_ERROR:
 						/* remote replica detected a duplicate ReplicaID */
 						slapi_log_error(SLAPI_LOG_FATAL, repl_plugin_name,
@@ -650,7 +642,6 @@ protocol_response2string (int response)
         case NSDS50_REPL_BELOW_PURGEPOINT:          return "csn below purge point";
         case NSDS50_REPL_INTERNAL_ERROR:            return "internal error";
         case NSDS50_REPL_REPLICA_RELEASE_SUCCEEDED: return "replica released";
-        case NSDS50_REPL_LEGACY_CONSUMER:           return "replica is a legacy consumer";						
 		case NSDS50_REPL_REPLICAID_ERROR:			return "duplicate replica ID detected";
 		case NSDS50_REPL_UPTODATE:					return "no change to send";
         default:                                    return "unknown error";
diff --git a/ldap/servers/plugins/replication/repl5_replica.c b/ldap/servers/plugins/replication/repl5_replica.c
index 8b53f3c..604279b 100644
--- a/ldap/servers/plugins/replication/repl5_replica.c
+++ b/ldap/servers/plugins/replication/repl5_replica.c
@@ -24,7 +24,6 @@
 #define RUV_SAVE_INTERVAL (30 * 1000) /* 30 seconds */
 
 #define REPLICA_RDN				 "cn=replica"
-#define CHANGELOG_RDN            "cn=legacy changelog"
 
 /*
  * A replica is a locally-held copy of a portion of the DIT.
@@ -41,8 +40,6 @@ struct replica {
 	PRUint32			updatedn_group_last_check;
 	int				updatedn_group_check_interval;
 	ReplicaType	 repl_type;			/* is this replica read-only ?			*/
-	PRBool  legacy_consumer;        /* if true, this replica is supplied by 4.0 consumer */
-	char*   legacy_purl;            /* partial url of the legacy supplier   */
 	ReplicaId repl_rid;				/* replicaID							*/
 	Object	*repl_ruv;				/* replica update vector				*/
 	PRBool repl_ruv_dirty;          /* Dirty flag for ruv                   */
@@ -96,8 +93,6 @@ static void abort_csn_callback(const CSN *csn, void *data);
 static void eq_cb_reap_tombstones(time_t when, void *arg);
 static CSN *_replica_get_purge_csn_nolock (const Replica *r);
 static void replica_get_referrals_nolock (const Replica *r, char ***referrals);
-static void replica_clear_legacy_referrals (const Slapi_DN *repl_root_sdn, char **referrals, const char *state);
-static void replica_remove_legacy_attr (const Slapi_DN *repl_root_sdn, const char *attr);
 static int replica_log_ruv_elements_nolock (const Replica *r);
 static void replica_replace_ruv_tombstone(Replica *r);
 static void start_agreements_for_replica (Replica *r, PRBool start);
@@ -259,14 +254,6 @@ replica_new_from_entry (Slapi_Entry *e, char *errortext, PRBool is_add_operation
 										   1000 * r->tombstone_reap_interval);
 	}
 
-    if (r->legacy_consumer)
-    {
-        legacy_consumer_init_referrals (r);
-        slapi_log_error(SLAPI_LOG_REPL, repl_plugin_name, "replica_new_from_entry: "
-                        "replica for %s was configured as legacy consumer\n",
-                        slapi_sdn_get_dn(r->repl_root));
-    }
-
     replica_check_for_tasks(r, e);
 
 done:
@@ -369,7 +356,6 @@ replica_destroy(void **arg)
 
 	/* slapi_ch_free accepts NULL pointer */
 	slapi_ch_free ((void**)&r->repl_name);
-	slapi_ch_free ((void**)&r->legacy_purl);    
 
 	if (r->repl_lock)
 	{
@@ -999,97 +985,6 @@ replica_set_type (Replica *r, ReplicaType type)
 }
 
 /* 
- * Returns PR_TRUE if this replica is a consumer of 4.0 server
- * and PR_FALSE otherwise
- */
-PRBool
-replica_is_legacy_consumer (const Replica *r)
-{
-	PR_ASSERT(r);
-	return r->legacy_consumer;
-}
-
-/* 
- * Sets the replica type.
- */
-void 
-replica_set_legacy_consumer (Replica *r, PRBool legacy_consumer)
-{
-    int legacy2mmr;
-	Slapi_DN *repl_root_sdn = NULL;
-	char **referrals = NULL;
-	char *replstate = NULL;
-	PR_ASSERT(r);
-
-    replica_lock(r->repl_lock);
-
-    legacy2mmr = r->legacy_consumer && !legacy_consumer;
-
-    /* making the server a regular 5.0 replica */
-    if (legacy2mmr)
-    {
-        slapi_ch_free ((void**)&r->legacy_purl);
-        /* Remove copiedFrom/copyingFrom attributes from the root entry */           
-		/* set the right state in the mapping tree */
-		if (r->repl_type == REPLICA_TYPE_READONLY)
-		{
-			replica_get_referrals_nolock (r, &referrals);
-			replstate = STATE_UPDATE_REFERRAL;
-		}
-		else /* updateable */
-		{
-			replstate = STATE_BACKEND;
-		}
-    }
-
-    r->legacy_consumer = legacy_consumer;
-    repl_root_sdn = slapi_sdn_dup(r->repl_root);
-    replica_unlock(r->repl_lock);
-
-    if (legacy2mmr)
-    {
-		replica_clear_legacy_referrals(repl_root_sdn, referrals, replstate);
-		/* Also change state of the mapping tree node and/or referrals */
-        replica_remove_legacy_attr (repl_root_sdn, type_copiedFrom);
-        replica_remove_legacy_attr (repl_root_sdn, type_copyingFrom);
-    }
-	charray_free(referrals);
-	slapi_sdn_free(&repl_root_sdn);
-}
-
-/* Gets partial url of the legacy supplier - applicable for legacy consumer only */
-char *
-replica_get_legacy_purl (const Replica *r)
-{
-    char *purl;
-
-    replica_lock(r->repl_lock);
-
-    PR_ASSERT (r->legacy_consumer);
-
-    purl = slapi_ch_strdup(r->legacy_purl);
-
-    replica_unlock(r->repl_lock);
-
-    return purl;
-}
-
-void 
-replica_set_legacy_purl (Replica *r, const char *purl)
-{
-    replica_lock(r->repl_lock);
-
-    PR_ASSERT (r->legacy_consumer);
-
-    /* slapi_ch_free accepts NULL pointer */
-    slapi_ch_free ((void**)&r->legacy_purl);
-
-    r->legacy_purl = slapi_ch_strdup (purl);
-
-    replica_unlock(r->repl_lock);
-}
-
-/* 
  * Returns true if sdn is the same as updatedn and false otherwise 
  */
 PRBool 
@@ -1484,7 +1379,7 @@ consumer5_set_mapping_tree_state_for_replica(const Replica *r, RUV *supplierRuv)
 	replica_get_referrals_nolock (r, &replica_referrals); /* replica_referrals has to be free'd */
 	
     /* JCMREPL - What if there's a Total update in progress? */
-	if( (r->repl_type==REPLICA_TYPE_READONLY) || (r->legacy_consumer) )
+	if(r->repl_type==REPLICA_TYPE_READONLY)
 	{
 		state_backend = 0;
 	}
@@ -1950,21 +1845,6 @@ _replica_init_from_config (Replica *r, Slapi_Entry *e, char *errortext)
         r->repl_type = REPLICA_TYPE_READONLY;
     }
 
-    /* get legacy consumer flag */
-    val = slapi_entry_attr_get_charptr (e, type_replicaLegacyConsumer);
-    if (val){
-        if (strcasecmp (val, "on") == 0 || strcasecmp (val, "yes") == 0 ||
-            strcasecmp (val, "true") == 0 || strcasecmp (val, "1") == 0)
-        {
-	        r->legacy_consumer = PR_TRUE;
-        } else {
-            r->legacy_consumer = PR_FALSE;
-        }
-        slapi_ch_free ((void**)&val);
-    } else {
-        r->legacy_consumer = PR_FALSE;
-    }
-
     /* grab and validate the backoff retry settings */
     if(slapi_entry_attr_exists(e, type_replicaBackoffMin)){
         backoff_min = slapi_entry_attr_get_int(e, type_replicaBackoffMin);
@@ -3633,52 +3513,6 @@ replica_get_referrals_nolock (const Replica *r, char ***referrals)
 	}
 }
 
-static void 
-replica_clear_legacy_referrals(const Slapi_DN *repl_root_sdn,
-							   char **referrals, const char *state)
-{
-	repl_set_mtn_state_and_referrals(repl_root_sdn, state, NULL, NULL, referrals);
-}
-
-static void 
-replica_remove_legacy_attr (const Slapi_DN *repl_root_sdn, const char *attr)
-{
-    Slapi_PBlock *pb;
-    Slapi_Mods smods;
-    LDAPControl **ctrls;
-    int rc;
-
-    pb = slapi_pblock_new ();
-    
-    slapi_mods_init(&smods, 1);
-    slapi_mods_add(&smods, LDAP_MOD_DELETE, attr, 0, NULL);
-   
-    
-    ctrls = (LDAPControl**)slapi_ch_malloc (2 * sizeof (LDAPControl*));
-    ctrls[0] = create_managedsait_control ();
-    ctrls[1] = NULL;
-    
-    /* remove copiedFrom/copyingFrom first */
-    slapi_modify_internal_set_pb_ext (pb, repl_root_sdn, 
-                                      slapi_mods_get_ldapmods_passout (&smods),
-                                      ctrls, NULL /*uniqueid */, 
-                                      repl_get_plugin_identity (PLUGIN_MULTIMASTER_REPLICATION) , 
-                                      0 /* operation_flags */);
- 
-    slapi_modify_internal_pb (pb);
-	slapi_pblock_get(pb, SLAPI_PLUGIN_INTOP_RESULT, &rc);
-    if (rc != LDAP_SUCCESS) 
-	{
-        /* this is not a fatal error because the attribute may not be there */
-		slapi_log_error(SLAPI_LOG_REPL, repl_plugin_name, "replica_remove_legacy_attr: "
-			"failed to remove legacy attribute %s for replica %s; LDAP error - %d\n", 
-            attr, slapi_sdn_get_dn(repl_root_sdn), rc);
-	}
-    
-    slapi_mods_done (&smods);
-    slapi_pblock_destroy (pb);
-}
-
 static int 
 replica_log_ruv_elements_nolock (const Replica *r)
 {
diff --git a/ldap/servers/plugins/replication/repl5_replica_config.c b/ldap/servers/plugins/replication/repl5_replica_config.c
index 14020b7..19a0534 100644
--- a/ldap/servers/plugins/replication/repl5_replica_config.c
+++ b/ldap/servers/plugins/replication/repl5_replica_config.c
@@ -224,8 +224,6 @@ replica_config_add (Slapi_PBlock *pb, Slapi_Entry* e, Slapi_Entry* entryAfter,
     }
 
 	/* Set the mapping tree node state, and the referrals from the RUV */
-    /* if this server is a 4.0 consumer the referrals are set by legacy plugin */
-    if (!replica_is_legacy_consumer (r))
 	    consumer5_set_mapping_tree_state_for_replica(r, NULL);
 
     /* ONREPL if replica is added as writable we need to execute protocol that
@@ -368,16 +366,9 @@ replica_config_modify (Slapi_PBlock *pb, Slapi_Entry* entryBefore, Slapi_Entry*
                 {
                     if (apply_mods) {
                         replica_set_referrals(r, NULL);
-                        if (!replica_is_legacy_consumer (r)) {
-                             consumer5_set_mapping_tree_state_for_replica(r, NULL);
-                        }
+                        consumer5_set_mapping_tree_state_for_replica(r, NULL);
                     }
                 }
-                else if (strcasecmp (config_attr, type_replicaLegacyConsumer) == 0)
-                {
-                    if (apply_mods)
-                        replica_set_legacy_consumer (r, PR_FALSE);
-                }
                 else if (strcasecmp (config_attr, type_replicaCleanRUV) == 0 ||
                          strcasecmp (config_attr, type_replicaAbortCleanRUV) == 0)
                 {
@@ -466,9 +457,7 @@ replica_config_modify (Slapi_PBlock *pb, Slapi_Entry* entryBefore, Slapi_Entry*
                         replica_set_referrals (r, vs);
                         slapi_mod_done(&smod);
                         slapi_valueset_free(vs);
-						if (!replica_is_legacy_consumer (r)) {
 							consumer5_set_mapping_tree_state_for_replica(r, NULL);
-						}
                     }
                 }
 				else if (strcasecmp (config_attr, type_replicaPurgeDelay) == 0)
@@ -494,18 +483,6 @@ replica_config_modify (Slapi_PBlock *pb, Slapi_Entry* entryBefore, Slapi_Entry*
 						replica_set_tombstone_reap_interval (r, interval);
 					}
 				}
-                else if (strcasecmp (config_attr, type_replicaLegacyConsumer) == 0)
-                {
-					if (apply_mods && config_attr_value[0])
-                    {
-                        PRBool legacy = (strcasecmp (config_attr_value, "on") == 0) ||
-                                        (strcasecmp (config_attr_value, "true") == 0) ||
-                                        (strcasecmp (config_attr_value, "yes") == 0) ||
-                                        (strcasecmp (config_attr_value, "1") == 0);
-
-                        replica_set_legacy_consumer (r, legacy);
-                    }
-                }
                 /* ignore modifiers attributes added by the server */
                 else if (slapi_attr_is_last_mod(config_attr))
                 {
@@ -1017,9 +994,7 @@ replica_config_change_type_and_id (Replica *r, const char *new_type,
         replica_set_rid(r, rid);
 
         /* Set the mapping tree node, and the list of referrals */
-        /* if this server is a 4.0 consumer the referrals are set by legacy plugin */
-        if (!replica_is_legacy_consumer(r))
-		    consumer5_set_mapping_tree_state_for_replica(r, NULL);
+	consumer5_set_mapping_tree_state_for_replica(r, NULL);
     }
 
     return LDAP_SUCCESS;
diff --git a/ldap/servers/plugins/replication/repl_connext.c b/ldap/servers/plugins/replication/repl_connext.c
index 164ff51..adf6642 100644
--- a/ldap/servers/plugins/replication/repl_connext.c
+++ b/ldap/servers/plugins/replication/repl_connext.c
@@ -35,7 +35,6 @@ void* consumer_connection_extension_constructor (void *object, void *parent)
 	}
 	else
 	{
-	    ext->is_legacy_replication_dn= 0;
 		ext->repl_protocol_version = REPL_PROTOCOL_UNKNOWN;
 		ext->replica_acquired = NULL;
 		ext->isreplicationsession= 0;
diff --git a/ldap/servers/plugins/replication/repl_extop.c b/ldap/servers/plugins/replication/repl_extop.c
index d2ed59c..c5b334b 100644
--- a/ldap/servers/plugins/replication/repl_extop.c
+++ b/ldap/servers/plugins/replication/repl_extop.c
@@ -773,13 +773,6 @@ multimaster_extop_StartNSDS50ReplicationRequest(Slapi_PBlock *pb)
 		}
 	}
 
-    /* check that this replica is not a 4.0 consumer */
-    if (replica_is_legacy_consumer (replica))
-    {
-        response = NSDS50_REPL_LEGACY_CONSUMER;
-        goto send_response;
-    }
-
 	/* Check that bind dn is authorized to supply replication updates */
 	slapi_pblock_get(pb, SLAPI_CONN_DN, &bind_dn); /* bind_dn is allocated */
 	bind_sdn = slapi_sdn_new_dn_passin(bind_dn);
diff --git a/ldap/servers/plugins/replication/repl_opext.c b/ldap/servers/plugins/replication/repl_opext.c
index 7f09507..f6c8eec 100644
--- a/ldap/servers/plugins/replication/repl_opext.c
+++ b/ldap/servers/plugins/replication/repl_opext.c
@@ -70,11 +70,6 @@ void* consumer_operation_extension_constructor (void *object, void *parent)
 			{
 				operation_set_flag((Slapi_Operation *)object,OP_FLAG_REPLICATED);
 			}
-			/* We set the Replication DN flag if session bound as replication dn */ 
-			if (connext->is_legacy_replication_dn)
-			{
-				operation_set_flag((Slapi_Operation *)object, OP_FLAG_LEGACY_REPLICATION_DN);
-			}
 		}
 	}
 	else
diff --git a/ldap/servers/plugins/replication/repl_rootdse.c b/ldap/servers/plugins/replication/repl_rootdse.c
index a9854cd..530840b 100644
--- a/ldap/servers/plugins/replication/repl_rootdse.c
+++ b/ldap/servers/plugins/replication/repl_rootdse.c
@@ -15,7 +15,6 @@
 #include <string.h>
 
 #include "repl.h"
-#include "cl4.h"
 #include "slapi-plugin.h"
  
 /* Forward Declartions */
